com.fasterxml.jackson.core.json.async

## Class NonBlockingJsonParserBase

- java.lang.Object
- - com.fasterxml.jackson.core.JsonParser
  - - com.fasterxml.jackson.core.base.ParserMinimalBase
    - - com.fasterxml.jackson.core.base.ParserBase
      - - com.fasterxml.jackson.core.json.async.NonBlockingJsonParserBase

All Implemented Interfaces:
  Versioned, Closeable, AutoCloseable

Direct Known Subclasses:
  NonBlockingJsonParser

    public abstract class NonBlockingJsonParserBase
    extends ParserBase

Intermediate base class for non-blocking JSON parsers.

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.core.JsonParser

`JsonParser.Feature, JsonParser.NumberType`

### Field Summary

Fields
`protected int` `_currBufferStart` Since we are fed content that may or may not start at zero offset, we need to keep track of the first byte within that buffer, to be able to calculate logical offset within input "stream"
`protected int` `_currInputRowAlt` Alternate row tracker, used to keep track of position by `\r` marker (whereas `_currInputRow` tracks `\n`).
`protected boolean` `_endOfInput` Flag that is sent when calling application indicates that there will be no more input to parse.
`protected int` `_majorState` Current main decoding state within logical tree
`protected int` `_majorStateAfterValue` Value of `_majorState` after completing a scalar value
`protected int` `_minorState` Additional indicator within state; contextually relevant for just that state
`protected int` `_minorStateAfterSplit` Secondary minor state indicator used during decoding of escapes and/or multi-byte Unicode characters
`protected int` `_nonStdTokenType` When tokenizing non-standard ("odd") tokens, this is the type to consider; also works as index to actual textual representation.
`protected int` `_pending32`
`protected int` `_pendingBytes`
`protected int` `_quad1`
`protected int[]` `_quadBuffer` Temporary buffer used for name parsing.
`protected int` `_quadLength`
`protected int` `_quoted32`
`protected int` `_quotedDigits`
`protected ByteQuadsCanonicalizer` `_symbols` Symbol table that contains field names encountered so far
`protected static int` `MAJOR_ARRAY_ELEMENT_FIRST`
`protected static int` `MAJOR_ARRAY_ELEMENT_NEXT`
`protected static int` `MAJOR_CLOSED` State after non-blocking input source has indicated that no more input is forthcoming AND we have exhausted all the input
`protected static int` `MAJOR_INITIAL` State right after parser has been constructed, before seeing the first byte to handle possible (but optional) BOM.
`protected static int` `MAJOR_OBJECT_FIELD_FIRST`
`protected static int` `MAJOR_OBJECT_FIELD_NEXT`
`protected static int` `MAJOR_OBJECT_VALUE`
`protected static int` `MAJOR_ROOT` State right after parser a root value has been finished, but next token has not yet been recognized.
`protected static int` `MINOR_COMMENT_C`
`protected static int` `MINOR_COMMENT_CLOSING_ASTERISK`
`protected static int` `MINOR_COMMENT_CPP`
`protected static int` `MINOR_COMMENT_LEADING_SLASH`
`protected static int` `MINOR_COMMENT_YAML`
`protected static int` `MINOR_FIELD_APOS_NAME`
`protected static int` `MINOR_FIELD_LEADING_COMMA`
`protected static int` `MINOR_FIELD_LEADING_WS`
`protected static int` `MINOR_FIELD_NAME`
`protected static int` `MINOR_FIELD_NAME_ESCAPE`
`protected static int` `MINOR_FIELD_UNQUOTED_NAME`
`protected static int` `MINOR_NUMBER_EXPONENT_DIGITS`
`protected static int` `MINOR_NUMBER_EXPONENT_MARKER`
`protected static int` `MINOR_NUMBER_FRACTION_DIGITS`
`protected static int` `MINOR_NUMBER_INTEGER_DIGITS`
`protected static int` `MINOR_NUMBER_MINUS`
`protected static int` `MINOR_NUMBER_MINUSZERO`
`protected static int` `MINOR_NUMBER_ZERO`
`protected static int` `MINOR_ROOT_BOM` State in which part of (UTF-8) BOM has been detected, but not yet completely.
`protected static int` `MINOR_ROOT_GOT_SEPARATOR` State between root-level value, having processed at least one white-space character, and expecting either more, start of a value, or end of input stream.
`protected static int` `MINOR_ROOT_NEED_SEPARATOR` State between root-level value, waiting for at least one white-space character as separator
`protected static int` `MINOR_VALUE_APOS_STRING`
`protected static int` `MINOR_VALUE_EXPECTING_COLON`
`protected static int` `MINOR_VALUE_EXPECTING_COMMA`
`protected static int` `MINOR_VALUE_LEADING_WS`
`protected static int` `MINOR_VALUE_STRING`
`protected static int` `MINOR_VALUE_STRING_ESCAPE`
`protected static int` `MINOR_VALUE_STRING_UTF8_2`
`protected static int` `MINOR_VALUE_STRING_UTF8_3`
`protected static int` `MINOR_VALUE_STRING_UTF8_4`
`protected static int` `MINOR_VALUE_TOKEN_ERROR` Special state at which point decoding of a non-quoted token has encountered a problem; that is, either not matching fully (like "truf" instead of "true", at "tru"), or not having trailing separator (or end of input), like "trueful".
`protected static int` `MINOR_VALUE_TOKEN_FALSE`
`protected static int` `MINOR_VALUE_TOKEN_NON_STD`
`protected static int` `MINOR_VALUE_TOKEN_NULL`
`protected static int` `MINOR_VALUE_TOKEN_TRUE`
`protected static int` `MINOR_VALUE_WS_AFTER_COMMA`
`protected static int` `NON_STD_TOKEN_INFINITY`
`protected static int` `NON_STD_TOKEN_MINUS_INFINITY`
`protected static int` `NON_STD_TOKEN_NAN`
`protected static int` `NON_STD_TOKEN_PLUS_INFINITY`
`protected static double[]` `NON_STD_TOKEN_VALUES`
`protected static String[]` `NON_STD_TOKENS`

### Fields inherited from class com.fasterxml.jackson.core.base.ParserBase

`_binaryValue, _byteArrayBuilder, _closed, _currInputProcessed, _currInputRow, _currInputRowStart, _expLength, _fractLength, _inputEnd, _inputPtr, _intLength, _ioContext, _nameCopied, _nameCopyBuffer, _nextToken, _numberBigDecimal, _numberBigInt, _numberDouble, _numberInt, _numberLong, _numberNegative, _numTypesValid, _parsingContext, _textBuffer, _tokenInputCol, _tokenInputRow, _tokenInputTotal`

### Fields inherited from class com.fasterxml.jackson.core.base.ParserMinimalBase

`_currToken, _lastClearedToken, BD_MAX_INT, BD_MAX_LONG, BD_MIN_INT, BD_MIN_LONG, BI_MAX_INT, BI_MAX_LONG, BI_MIN_INT, BI_MIN_LONG, CHAR_NULL, INT_0, INT_9, INT_APOS, INT_ASTERISK, INT_BACKSLASH, INT_COLON, INT_COMMA, INT_CR, INT_e, INT_E, INT_HASH, INT_LBRACKET, INT_LCURLY, INT_LF, INT_MINUS, INT_PERIOD, INT_PLUS, INT_QUOTE, INT_RBRACKET, INT_RCURLY, INT_SLASH, INT_SPACE, INT_TAB, MAX_ERROR_TOKEN_LENGTH, MAX_INT_D, MAX_INT_L, MAX_LONG_D, MIN_INT_D, MIN_INT_L, MIN_LONG_D, NO_BYTES, NO_INTS, NR_BIGDECIMAL, NR_BIGINT, NR_DOUBLE, NR_FLOAT, NR_INT, NR_LONG, NR_UNKNOWN`

### Fields inherited from class com.fasterxml.jackson.core.JsonParser

`_features, _requestPayload`

### Constructor Summary

Constructors
Constructor and Description
`NonBlockingJsonParserBase(IOContext ctxt, int parserFeatures, ByteQuadsCanonicalizer sym)`

### Method Summary

Methods
`protected String` `_addName(int[] quads, int qlen, int lastQuadBytes)` This is the main workhorse method used when we take a symbol table miss.
`protected JsonToken` `_closeArrayScope()`
`protected void` `_closeInput()`
`protected JsonToken` `_closeObjectScope()`
`protected JsonToken` `_eofAsNextToken()` Helper method called at point when all input has been exhausted and input feeder has indicated no more input will be forthcoming.
`protected JsonToken` `_fieldComplete(String name)`
`protected String` `_findName(int q1, int lastQuadBytes)`
`protected String` `_findName(int q1, int q2, int lastQuadBytes)`
`protected String` `_findName(int q1, int q2, int q3, int lastQuadBytes)`
`protected String` `_getText2(JsonToken t)`
`protected String` `_nonStdToken(int type)`
`protected static int` `_padLastQuad(int q, int bytes)` Helper method needed to fix [jackson-core#148], masking of 0x00 character
`protected void` `_releaseBuffers()` Method called to release internal buffers owned by the base reader.
`protected void` `_reportInvalidChar(int c)`
`protected void` `_reportInvalidInitial(int mask)`
`protected void` `_reportInvalidOther(int mask)`
`protected void` `_reportInvalidOther(int mask, int ptr)`
`protected JsonToken` `_startArrayScope()`
`protected JsonToken` `_startObjectScope()`
`protected void` `_updateTokenLocation()`
`protected JsonToken` `_valueComplete(JsonToken t)`
`protected JsonToken` `_valueCompleteInt(int value, String asText)`
`protected JsonToken` `_valueNonStdNumberComplete(int type)`
`boolean` `canParseAsync()` Method that can be called to determine if this parser instance uses non-blocking ("asynchronous") input access for decoding or not.
`byte[]` `getBinaryValue(Base64Variant b64variant)` Method that can be used to read (and consume -- results may not be accessible using other methods after the call) base64-encoded binary data included in the current textual JSON value.
`ObjectCodec` `getCodec()` Accessor for `ObjectCodec` associated with this parser, if any.
`JsonLocation` `getCurrentLocation()` Method that returns location of the last processed character; usually for error reporting purposes
`Object` `getEmbeddedObject()` Accessor that can be called if (and only if) the current token is `JsonToken.VALUE_EMBEDDED_OBJECT`.
`Object` `getInputSource()` Method that can be used to get access to object that is used to access input being parsed; this is usually either `InputStream` or `Reader`, depending on what parser was constructed with.
`String` `getText()` Method for accessing textual representation of the current event; if no current event (before first call to `ParserMinimalBase.nextToken()`, or after encountering end-of-input), returns null.
`int` `getText(Writer writer)` Method to read the textual representation of the current token in chunks and pass it to the given Writer.
`char[]` `getTextCharacters()` Method similar to `JsonParser.getText()`, but that will return underlying (unmodifiable) character array that contains textual value, instead of constructing a String object to contain this information.
`int` `getTextLength()` Accessor used with `JsonParser.getTextCharacters()`, to know length of String stored in returned buffer.
`int` `getTextOffset()` Accessor used with `JsonParser.getTextCharacters()`, to know offset of the first text content character within buffer.
`JsonLocation` `getTokenLocation()` Method that return the starting location of the current token; that is, position of the first character from input that starts the current token.
`String` `getValueAsString()` Method that will try to convert value of current token to a `String`.
`String` `getValueAsString(String defValue)` Method that will try to convert value of current token to a `String`.
`boolean` `hasTextCharacters()` Method that can be used to determine whether calling of `JsonParser.getTextCharacters()` would be the most efficient way to access textual content for the event parser currently points to.
`int` `readBinaryValue(Base64Variant b64variant, OutputStream out)` Similar to `JsonParser.readBinaryValue(OutputStream)` but allows explicitly specifying base64 variant to use.
`abstract int` `releaseBuffered(OutputStream out)` Method that can be called to push back any content that has been read but not consumed by the parser.
`void` `setCodec(ObjectCodec c)` Setter that allows defining `ObjectCodec` associated with this parser, if any.
`protected ByteQuadsCanonicalizer` `symbolTableForTests()`

### Methods inherited from class com.fasterxml.jackson.core.base.ParserBase

`_checkStdFeatureChanges, _decodeBase64Escape, _decodeBase64Escape, _decodeEscaped, _eofAsNextChar, _finishString, _getByteArrayBuilder, _getSourceReference, _handleEOF, _parseIntValue, _parseNumericValue, _reportMismatchedEndMarker, close, convertNumberToBigDecimal, convertNumberToBigInteger, convertNumberToDouble, convertNumberToInt, convertNumberToLong, disable, enable, getBigIntegerValue, getCurrentName, getCurrentValue, getDecimalValue, getDoubleValue, getFloatValue, getIntValue, getLongValue, getNumberType, getNumberValue, getParsingContext, getTokenCharacterOffset, getTokenColumnNr, getTokenLineNr, growArrayBy, isClosed, isNaN, loadMore, loadMoreGuaranteed, overrideCurrentName, overrideStdFeatures, reportInvalidBase64Char, reportInvalidBase64Char, reset, resetAsNaN, resetFloat, resetInt, setCurrentValue, setFeatureMask, version`

### Methods inherited from class com.fasterxml.jackson.core.base.ParserMinimalBase

`_ascii, _asciiBytes, _constructError, _decodeBase64, _getCharDesc, _handleUnrecognizedCharacterEscape, _hasTextualNull, _reportError, _reportError, _reportError, _reportInvalidEOF, _reportInvalidEOF, _reportInvalidEOF, _reportInvalidEOFInValue, _reportInvalidEOFInValue, _reportMissingRootWS, _reportUnexpectedChar, _throwInternal, _throwInvalidSpace, _throwUnquotedSpace, _wrapError, clearCurrentToken, currentToken, currentTokenId, getCurrentToken, getCurrentTokenId, getLastClearedToken, getValueAsBoolean, getValueAsDouble, getValueAsInt, getValueAsInt, getValueAsLong, getValueAsLong, hasCurrentToken, hasToken, hasTokenId, isExpectedStartArrayToken, isExpectedStartObjectToken, nextToken, nextValue, reportInvalidNumber, reportOverflowInt, reportOverflowLong, reportUnexpectedNumberChar, skipChildren`

### Methods inherited from class com.fasterxml.jackson.core.JsonParser

`_codec, _constructError, _reportUnsupportedOperation, canReadObjectId, canReadTypeId, canUseSchema, configure, currentName, finishToken, getBinaryValue, getBooleanValue, getByteValue, getFeatureMask, getFormatFeatures, getNonBlockingInputFeeder, getObjectId, getSchema, getShortValue, getTypeId, getValueAsBoolean, getValueAsDouble, isEnabled, nextBooleanValue, nextFieldName, nextFieldName, nextIntValue, nextLongValue, nextTextValue, overrideFormatFeatures, readBinaryValue, readValueAs, readValueAs, readValueAsTree, readValuesAs, readValuesAs, releaseBuffered, requiresCustomCodec, setRequestPayloadOnError, setRequestPayloadOnError, setRequestPayloadOnError, setSchema`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### MAJOR_INITIAL

    protected static final int MAJOR_INITIAL

State right after parser has been constructed, before seeing the first byte to handle possible (but optional) BOM.

See Also:
  Constant Field Values

#### MAJOR_ROOT

    protected static final int MAJOR_ROOT

State right after parser a root value has been finished, but next token has not yet been recognized.

See Also:
  Constant Field Values

#### MAJOR_OBJECT_FIELD_FIRST

    protected static final int MAJOR_OBJECT_FIELD_FIRST

See Also:
  Constant Field Values

#### MAJOR_OBJECT_FIELD_NEXT

    protected static final int MAJOR_OBJECT_FIELD_NEXT

See Also:
  Constant Field Values

#### MAJOR_OBJECT_VALUE

    protected static final int MAJOR_OBJECT_VALUE

See Also:
  Constant Field Values

#### MAJOR_ARRAY_ELEMENT_FIRST

    protected static final int MAJOR_ARRAY_ELEMENT_FIRST

See Also:
  Constant Field Values

#### MAJOR_ARRAY_ELEMENT_NEXT

    protected static final int MAJOR_ARRAY_ELEMENT_NEXT

See Also:
  Constant Field Values

#### MAJOR_CLOSED

    protected static final int MAJOR_CLOSED

State after non-blocking input source has indicated that no more input is forthcoming AND we have exhausted all the input

See Also:
  Constant Field Values

#### MINOR_ROOT_BOM

    protected static final int MINOR_ROOT_BOM

State in which part of (UTF-8) BOM has been detected, but not yet completely.

See Also:
  Constant Field Values

#### MINOR_ROOT_NEED_SEPARATOR

    protected static final int MINOR_ROOT_NEED_SEPARATOR

State between root-level value, waiting for at least one white-space character as separator

See Also:
  Constant Field Values

#### MINOR_ROOT_GOT_SEPARATOR

    protected static final int MINOR_ROOT_GOT_SEPARATOR

State between root-level value, having processed at least one white-space character, and expecting either more, start of a value, or end of input stream.

See Also:
  Constant Field Values

#### MINOR_FIELD_LEADING_WS

    protected static final int MINOR_FIELD_LEADING_WS

See Also:
  Constant Field Values

#### MINOR_FIELD_LEADING_COMMA

    protected static final int MINOR_FIELD_LEADING_COMMA

See Also:
  Constant Field Values

#### MINOR_FIELD_NAME

    protected static final int MINOR_FIELD_NAME

See Also:
  Constant Field Values

#### MINOR_FIELD_NAME_ESCAPE

    protected static final int MINOR_FIELD_NAME_ESCAPE

See Also:
  Constant Field Values

#### MINOR_FIELD_APOS_NAME

    protected static final int MINOR_FIELD_APOS_NAME

See Also:
  Constant Field Values

#### MINOR_FIELD_UNQUOTED_NAME

    protected static final int MINOR_FIELD_UNQUOTED_NAME

See Also:
  Constant Field Values

#### MINOR_VALUE_LEADING_WS

    protected static final int MINOR_VALUE_LEADING_WS

See Also:
  Constant Field Values

#### MINOR_VALUE_EXPECTING_COMMA

    protected static final int MINOR_VALUE_EXPECTING_COMMA

See Also:
  Constant Field Values

#### MINOR_VALUE_EXPECTING_COLON

    protected static final int MINOR_VALUE_EXPECTING_COLON

See Also:
  Constant Field Values

#### MINOR_VALUE_WS_AFTER_COMMA

    protected static final int MINOR_VALUE_WS_AFTER_COMMA

See Also:
  Constant Field Values

#### MINOR_VALUE_TOKEN_NULL

    protected static final int MINOR_VALUE_TOKEN_NULL

See Also:
  Constant Field Values

#### MINOR_VALUE_TOKEN_TRUE

    protected static final int MINOR_VALUE_TOKEN_TRUE

See Also:
  Constant Field Values

#### MINOR_VALUE_TOKEN_FALSE

    protected static final int MINOR_VALUE_TOKEN_FALSE

See Also:
  Constant Field Values

#### MINOR_VALUE_TOKEN_NON_STD

    protected static final int MINOR_VALUE_TOKEN_NON_STD

See Also:
  Constant Field Values

#### MINOR_NUMBER_MINUS

    protected static final int MINOR_NUMBER_MINUS

See Also:
  Constant Field Values

#### MINOR_NUMBER_ZERO

    protected static final int MINOR_NUMBER_ZERO

See Also:
  Constant Field Values

#### MINOR_NUMBER_MINUSZERO

    protected static final int MINOR_NUMBER_MINUSZERO

See Also:
  Constant Field Values

#### MINOR_NUMBER_INTEGER_DIGITS

    protected static final int MINOR_NUMBER_INTEGER_DIGITS

See Also:
  Constant Field Values

#### MINOR_NUMBER_FRACTION_DIGITS

    protected static final int MINOR_NUMBER_FRACTION_DIGITS

See Also:
  Constant Field Values

#### MINOR_NUMBER_EXPONENT_MARKER

    protected static final int MINOR_NUMBER_EXPONENT_MARKER

See Also:
  Constant Field Values

#### MINOR_NUMBER_EXPONENT_DIGITS

    protected static final int MINOR_NUMBER_EXPONENT_DIGITS

See Also:
  Constant Field Values

#### MINOR_VALUE_STRING

    protected static final int MINOR_VALUE_STRING

See Also:
  Constant Field Values

#### MINOR_VALUE_STRING_ESCAPE

    protected static final int MINOR_VALUE_STRING_ESCAPE

See Also:
  Constant Field Values

#### MINOR_VALUE_STRING_UTF8_2

    protected static final int MINOR_VALUE_STRING_UTF8_2

See Also:
  Constant Field Values

#### MINOR_VALUE_STRING_UTF8_3

    protected static final int MINOR_VALUE_STRING_UTF8_3

See Also:
  Constant Field Values

#### MINOR_VALUE_STRING_UTF8_4

    protected static final int MINOR_VALUE_STRING_UTF8_4

See Also:
  Constant Field Values

#### MINOR_VALUE_APOS_STRING

    protected static final int MINOR_VALUE_APOS_STRING

See Also:
  Constant Field Values

#### MINOR_VALUE_TOKEN_ERROR

    protected static final int MINOR_VALUE_TOKEN_ERROR

Special state at which point decoding of a non-quoted token has encountered a problem; that is, either not matching fully (like "truf" instead of "true", at "tru"), or not having trailing separator (or end of input), like "trueful". Attempt is made, then, to decode likely full input token to report suitable error.

See Also:
  Constant Field Values

#### MINOR_COMMENT_LEADING_SLASH

    protected static final int MINOR_COMMENT_LEADING_SLASH

See Also:
  Constant Field Values

#### MINOR_COMMENT_CLOSING_ASTERISK

    protected static final int MINOR_COMMENT_CLOSING_ASTERISK

See Also:
  Constant Field Values

#### MINOR_COMMENT_C

    protected static final int MINOR_COMMENT_C

See Also:
  Constant Field Values

#### MINOR_COMMENT_CPP

    protected static final int MINOR_COMMENT_CPP

See Also:
  Constant Field Values

#### MINOR_COMMENT_YAML

    protected static final int MINOR_COMMENT_YAML

See Also:
  Constant Field Values

#### _symbols

    protected final ByteQuadsCanonicalizer _symbols

Symbol table that contains field names encountered so far

#### _quadBuffer

    protected int[] _quadBuffer

Temporary buffer used for name parsing.

#### _quadLength

    protected int _quadLength

#### _quad1

    protected int _quad1

#### _pending32

    protected int _pending32

#### _pendingBytes

    protected int _pendingBytes

#### _quoted32

    protected int _quoted32

#### _quotedDigits

    protected int _quotedDigits

#### _majorState

    protected int _majorState

Current main decoding state within logical tree

#### _majorStateAfterValue

    protected int _majorStateAfterValue

Value of `_majorState` after completing a scalar value

#### _minorState

    protected int _minorState

Additional indicator within state; contextually relevant for just that state

#### _minorStateAfterSplit

    protected int _minorStateAfterSplit

Secondary minor state indicator used during decoding of escapes and/or multi-byte Unicode characters

#### _endOfInput

    protected boolean _endOfInput

Flag that is sent when calling application indicates that there will be no more input to parse.

#### NON_STD_TOKEN_NAN

    protected static final int NON_STD_TOKEN_NAN

See Also:
  Constant Field Values

#### NON_STD_TOKEN_INFINITY

    protected static final int NON_STD_TOKEN_INFINITY

See Also:
  Constant Field Values

#### NON_STD_TOKEN_PLUS_INFINITY

    protected static final int NON_STD_TOKEN_PLUS_INFINITY

See Also:
  Constant Field Values

#### NON_STD_TOKEN_MINUS_INFINITY

    protected static final int NON_STD_TOKEN_MINUS_INFINITY

See Also:
  Constant Field Values

#### NON_STD_TOKENS

    protected static final String[] NON_STD_TOKENS

#### NON_STD_TOKEN_VALUES

    protected static final double[] NON_STD_TOKEN_VALUES

#### _nonStdTokenType

    protected int _nonStdTokenType

When tokenizing non-standard ("odd") tokens, this is the type to consider; also works as index to actual textual representation.

#### _currBufferStart

    protected int _currBufferStart

Since we are fed content that may or may not start at zero offset, we need to keep track of the first byte within that buffer, to be able to calculate logical offset within input "stream"

#### _currInputRowAlt

    protected int _currInputRowAlt

Alternate row tracker, used to keep track of position by `\r` marker (whereas `_currInputRow` tracks `\n`). Used to simplify tracking of linefeeds, assuming that input typically uses various linefeed combinations (`\r`, `\n` or `\r\n`) consistently, in which case we can simply choose max of two row candidates.

### Constructor Detail

#### NonBlockingJsonParserBase

    public NonBlockingJsonParserBase(IOContext ctxt,
                             int parserFeatures,
                             ByteQuadsCanonicalizer sym)

### Method Detail

#### getCodec

    public ObjectCodec getCodec()

Description copied from class: `JsonParser`
Accessor for `ObjectCodec` associated with this parser, if any. Codec is used by `JsonParser.readValueAs(Class)` method (and its variants).

Specified by:
  `getCodec` in class `JsonParser`

#### setCodec

    public void setCodec(ObjectCodec c)

Description copied from class: `JsonParser`
Setter that allows defining `ObjectCodec` associated with this parser, if any. Codec is used by `JsonParser.readValueAs(Class)` method (and its variants).

Specified by:
  `setCodec` in class `JsonParser`

#### canParseAsync

    public boolean canParseAsync()

Description copied from class: `JsonParser`
Method that can be called to determine if this parser instance uses non-blocking ("asynchronous") input access for decoding or not. Access mode is determined by earlier calls via `JsonFactory`; it may not be changed after construction.

If non-blocking decoding is u (@code true}, it is possible to call `JsonParser.getNonBlockingInputFeeder()` to obtain object to use for feeding input; otherwise (`false` returned) input is read by blocking

Overrides:
  `canParseAsync` in class `JsonParser`
Since:
  2.9

#### symbolTableForTests

    protected ByteQuadsCanonicalizer symbolTableForTests()

#### releaseBuffered

    public abstract int releaseBuffered(OutputStream out)
                                 throws IOException

Description copied from class: `JsonParser`
Method that can be called to push back any content that has been read but not consumed by the parser. This is usually done after reading all content of interest using parser. Content is released by writing it to given stream if possible; if underlying input is byte-based it can released, if not (char-based) it can not.

Overrides:
  `releaseBuffered` in class `JsonParser`
Returns:
  -1 if the underlying content source is not byte based (that is, input can not be sent to `OutputStream`; otherwise number of bytes released (0 if there was nothing to release)
Throws:
  `IOException` - if write to stream threw exception

#### _releaseBuffers

    protected void _releaseBuffers()
                            throws IOException

Description copied from class: `ParserBase`
Method called to release internal buffers owned by the base reader. This may be called along with `ParserBase._closeInput()` (for example, when explicitly closing this reader instance), or separately (if need be).

Overrides:
  `_releaseBuffers` in class `ParserBase`
Throws:
  `IOException`

#### getInputSource

    public Object getInputSource()

Description copied from class: `JsonParser`
Method that can be used to get access to object that is used to access input being parsed; this is usually either `InputStream` or `Reader`, depending on what parser was constructed with. Note that returned value may be null in some cases; including case where parser implementation does not want to exposed raw source to caller. In cases where input has been decorated, object returned here is the decorated version; this allows some level of interaction between users of parser and decorator object.

In general use of this accessor should be considered as "last effort", i.e. only used if no other mechanism is applicable.

Overrides:
  `getInputSource` in class `JsonParser`

#### _closeInput

    protected void _closeInput()
                        throws IOException

Specified by:
  `_closeInput` in class `ParserBase`
Throws:
  `IOException`

#### hasTextCharacters

    public boolean hasTextCharacters()

Description copied from class: `JsonParser`
Method that can be used to determine whether calling of `JsonParser.getTextCharacters()` would be the most efficient way to access textual content for the event parser currently points to.

Default implementation simply returns false since only actual implementation class has knowledge of its internal buffering state. Implementations are strongly encouraged to properly override this method, to allow efficient copying of content by other code.

Overrides:
  `hasTextCharacters` in class `ParserBase`
Returns:
  True if parser currently has character array that can be efficiently returned via `JsonParser.getTextCharacters()`; false means that it may or may not exist

#### getCurrentLocation

    public JsonLocation getCurrentLocation()

Description copied from class: `ParserBase`
Method that returns location of the last processed character; usually for error reporting purposes

Overrides:
  `getCurrentLocation` in class `ParserBase`

#### getTokenLocation

    public JsonLocation getTokenLocation()

Description copied from class: `ParserBase`
Method that return the starting location of the current token; that is, position of the first character from input that starts the current token.

Overrides:
  `getTokenLocation` in class `ParserBase`

#### getText

    public String getText()
                   throws IOException

Method for accessing textual representation of the current event; if no current event (before first call to `ParserMinimalBase.nextToken()`, or after encountering end-of-input), returns null. Method can be called for any event.

Specified by:
  `getText` in class `ParserMinimalBase`
Throws:
  `IOException`

#### _getText2

    protected final String _getText2(JsonToken t)

#### getText

    public int getText(Writer writer)
                throws IOException

Description copied from class: `JsonParser`
Method to read the textual representation of the current token in chunks and pass it to the given Writer. Conceptually same as calling:

      writer.write(parser.getText());

but should typically be more efficient as longer content does need to be combined into a single `String` to return, and write can occur directly from intermediate buffers Jackson uses.

Overrides:
  `getText` in class `JsonParser`
Returns:
  The number of characters written to the Writer
Throws:
  `IOException`

#### getValueAsString

    public String getValueAsString()
                            throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a `String`. JSON Strings map naturally; scalar values get converted to their textual representation. If representation can not be converted to a String value (including structured types like Objects and Arrays and null token), default value of null will be returned; no exceptions are thrown.

Overrides:
  `getValueAsString` in class `ParserMinimalBase`
Throws:
  `IOException`

#### getValueAsString

    public String getValueAsString(String defValue)
                            throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a `String`. JSON Strings map naturally; scalar values get converted to their textual representation. If representation can not be converted to a String value (including structured types like Objects and Arrays and null token), specified default value will be returned; no exceptions are thrown.

Overrides:
  `getValueAsString` in class `ParserMinimalBase`
Throws:
  `IOException`

#### getTextCharacters

    public char[] getTextCharacters()
                             throws IOException

Description copied from class: `JsonParser`
Method similar to `JsonParser.getText()`, but that will return underlying (unmodifiable) character array that contains textual value, instead of constructing a String object to contain this information. Note, however, that:

- Textual contents are not guaranteed to start at index 0 (rather, call `JsonParser.getTextOffset()`) to know the actual offset
- Length of textual contents may be less than the length of returned buffer: call `JsonParser.getTextLength()` for actual length of returned content.

Note that caller MUST NOT modify the returned character array in any way -- doing so may corrupt current parser state and render parser instance useless.

The only reason to call this method (over `JsonParser.getText()`) is to avoid construction of a String object (which will make a copy of contents).

Specified by:
  `getTextCharacters` in class `ParserMinimalBase`
Throws:
  `IOException`

#### getTextLength

    public int getTextLength()
                      throws IOException

Description copied from class: `JsonParser`
Accessor used with `JsonParser.getTextCharacters()`, to know length of String stored in returned buffer.

Specified by:
  `getTextLength` in class `ParserMinimalBase`
Returns:
  Number of characters within buffer returned by `JsonParser.getTextCharacters()` that are part of textual content of the current token.
Throws:
  `IOException`

#### getTextOffset

    public int getTextOffset()
                      throws IOException

Description copied from class: `JsonParser`
Accessor used with `JsonParser.getTextCharacters()`, to know offset of the first text content character within buffer.

Specified by:
  `getTextOffset` in class `ParserMinimalBase`
Returns:
  Offset of the first character within buffer returned by `JsonParser.getTextCharacters()` that is part of textual content of the current token.
Throws:
  `IOException`

#### getBinaryValue

    public byte[] getBinaryValue(Base64Variant b64variant)
                          throws IOException

Description copied from class: `JsonParser`
Method that can be used to read (and consume -- results may not be accessible using other methods after the call) base64-encoded binary data included in the current textual JSON value. It works similar to getting String value via `JsonParser.getText()` and decoding result (except for decoding part), but should be significantly more performant.

Note that non-decoded textual contents of the current token are not guaranteed to be accessible after this method is called. Current implementation, for example, clears up textual content during decoding. Decoded binary content, however, will be retained until parser is advanced to the next event.

Overrides:
  `getBinaryValue` in class `ParserBase`
Parameters:
  `b64variant` - Expected variant of base64 encoded content (see `Base64Variants` for definitions of "standard" variants).
Returns:
  Decoded binary data
Throws:
  `IOException`

#### readBinaryValue

    public int readBinaryValue(Base64Variant b64variant,
                      OutputStream out)
                        throws IOException

Description copied from class: `JsonParser`
Similar to `JsonParser.readBinaryValue(OutputStream)` but allows explicitly specifying base64 variant to use.

Overrides:
  `readBinaryValue` in class `JsonParser`
Parameters:
  `b64variant` - base64 variant to use
  `out` - Output stream to use for passing decoded binary data
Returns:
  Number of bytes that were decoded and written via `OutputStream`
Throws:
  `IOException`

#### getEmbeddedObject

    public Object getEmbeddedObject()
                             throws IOException

Description copied from class: `JsonParser`
Accessor that can be called if (and only if) the current token is `JsonToken.VALUE_EMBEDDED_OBJECT`. For other token types, null is returned.

Note: only some specialized parser implementations support embedding of objects (usually ones that are facades on top of non-streaming sources, such as object trees). One exception is access to binary content (whether via base64 encoding or not) which typically is accessible using this method, as well as `JsonParser.getBinaryValue()`.

Overrides:
  `getEmbeddedObject` in class `JsonParser`
Throws:
  `IOException`

#### _startArrayScope

    protected final JsonToken _startArrayScope()
                                        throws IOException

Throws:
  `IOException`

#### _startObjectScope

    protected final JsonToken _startObjectScope()
                                         throws IOException

Throws:
  `IOException`

#### _closeArrayScope

    protected final JsonToken _closeArrayScope()
                                        throws IOException

Throws:
  `IOException`

#### _closeObjectScope

    protected final JsonToken _closeObjectScope()
                                         throws IOException

Throws:
  `IOException`

#### _findName

    protected final String _findName(int q1,
                   int lastQuadBytes)
                              throws JsonParseException

Throws:
  `JsonParseException`

#### _findName

    protected final String _findName(int q1,
                   int q2,
                   int lastQuadBytes)
                              throws JsonParseException

Throws:
  `JsonParseException`

#### _findName

    protected final String _findName(int q1,
                   int q2,
                   int q3,
                   int lastQuadBytes)
                              throws JsonParseException

Throws:
  `JsonParseException`

#### _addName

    protected final String _addName(int[] quads,
                  int qlen,
                  int lastQuadBytes)
                             throws JsonParseException

This is the main workhorse method used when we take a symbol table miss. It needs to demultiplex individual bytes, decode multi-byte chars (if any), and then construct Name instance and add it to the symbol table.

Throws:
  `JsonParseException`

#### _padLastQuad

    protected static final int _padLastQuad(int q,
                   int bytes)

Helper method needed to fix [jackson-core#148], masking of 0x00 character

#### _eofAsNextToken

    protected final JsonToken _eofAsNextToken()
                                       throws IOException

Helper method called at point when all input has been exhausted and input feeder has indicated no more input will be forthcoming.

Throws:
  `IOException`

#### _fieldComplete

    protected final JsonToken _fieldComplete(String name)
                                      throws IOException

Throws:
  `IOException`

#### _valueComplete

    protected final JsonToken _valueComplete(JsonToken t)
                                      throws IOException

Throws:
  `IOException`

#### _valueCompleteInt

    protected final JsonToken _valueCompleteInt(int value,
                              String asText)
                                         throws IOException

Throws:
  `IOException`

#### _valueNonStdNumberComplete

    protected final JsonToken _valueNonStdNumberComplete(int type)
                                                  throws IOException

Throws:
  `IOException`

#### _nonStdToken

    protected final String _nonStdToken(int type)

#### _updateTokenLocation

    protected final void _updateTokenLocation()

#### _reportInvalidChar

    protected void _reportInvalidChar(int c)
                               throws JsonParseException

Throws:
  `JsonParseException`

#### _reportInvalidInitial

    protected void _reportInvalidInitial(int mask)
                                  throws JsonParseException

Throws:
  `JsonParseException`

#### _reportInvalidOther

    protected void _reportInvalidOther(int mask,
                           int ptr)
                                throws JsonParseException

Throws:
  `JsonParseException`

#### _reportInvalidOther

    protected void _reportInvalidOther(int mask)
                                throws JsonParseException

Throws:
  `JsonParseException`